using System;
using System.Collections.Generic;
using System.Text;

using System.Runtime.InteropServices;

namespace MLib.Wrapper
{
    [Guid("270A8BA3-E2F4-44eb-B2A9-5FD86614563C")]
    [ClassInterface(ClassInterfaceType.None)]
    [ComSourceInterfaces(typeof(ICommonWrapperEvents))]
    [ProgId("COMCommonWrapper")]
    public class CommonWrapper : ICommonWrapper
    {
        #region Members
        public event Run Run;
        public event Error Error;
        public event Finally Finally;
        #endregion

        #region Internals

        public CommonWrapper()
        {
        }

        #endregion

        #region Functions

        public void Execute()
        {
            OnRun();
        }

        private void OnRun()
        {
            try
            {
                Run();
            }
            catch (Exception e)
            {
                try
                {
                    OnError(e);
                }
                catch { }
            }
            finally
            {
                try
                {
                    OnFinally();
                }
                catch { }
            }
        }

        private void OnError(Exception e)
        {
            if (e != null)
                Error(e.Message);
        }

        private void OnFinally()
        {
            Finally();
        }
        #endregion
    }
}
